LPARAM lcAlias,lcServer,lcUser,lcPWD,lcExList
* lcAlias    - Alias of opened table
* lcServer   - ORCL of ORACLE
* lcUser     - User
* lcPWD      - Pasword

* Nvratov konstanty
#DEFINE __DBF2ORA_ErrOK                0 && 
#DEFINE __DBF2ORA_ErrConnectionFailed -1 && Nepodailo se otevr spojen
#DEFINE __DBF2ORA_ErrFewParameters    -3 && Mlo parametr
#DEFINE __DBF2ORA_ErrNoTables         -4 && Nepodailo se zskat seznam tabulek
#DEFINE __DBF2ORA_ErrCannotCTable     -5 && Nepodailo se vytvoit tabulku
#DEFINE __DBF2ORA_ErrCannotDTable     -6 && Nepodailo se smazat tabulku
#DEFINE __DBF2ORA_ErrNotaTable        -7 && Tabulka je pohled nebo systmov tabulka
#DEFINE __DBF2ORA_ErrNotInsert        -8 && Nepodailo se zaloit vtu
#DEFINE __DBF2ORA_ErrNotDelete        -9 && Nepodailo se smazat vty
#DEFINE __DBF2ORA_ErrAliasNotOpen    -10 && Alias nen oteven



IF PCOUNT()<4
   RETURN __DBF2ORA_ErrFewParameters
ENDIF

IF !USED(lcAlias)
   RETURN __DBF2ORA_ErrAliasNotOpen
ENDIF

LOCAL lcSQL,lihdbc,liErr,liODBChdbc,lcPom,lii,lcCRKey,lcTable,;
      lcATables,llExists,lcSQLI,;
      llReCreate,llReFill

LOCAL ARRAY laFields(1)

llReCreate=.T.     && M se tabulka znovu vytvoit, pokud existuje?
llReFill=.T.       && M se tabulka znova naplnit?
*lcDriver="{ORA}" && Nzev ODBC driveru
lcDriver="{microsoft odbc for oracle}" && Nzev ODBC driveru

=SQLSETPROP(0,"Asynchronous",.F.) && Nastav Asynchronn provoz
=SQLSETPROP(0,"Transactions",1)   && Nastav Automatick transakce
=SQLSETPROP(0,"DispLogin",3)      && Nikdy nezobrazuj dialog pi pihlen


* Pipojen na MDB soubor
* Vytvoen a naplnn tabulky
lihdbc=SQLSTRINGCONNECT("Driver="+lcDriver+";SERVER="+lcServer+";uid="+lcUser+";pwd="+lcPWD)
IF lihdbc<=0
   RETURN __DBF2ORA_ErrConnectionFailed
ENDIF

lcPom=DBF(lcAlias)
lii=RAT("\",lcPom)
lcTable=IIF(lii>0,SUBS(lcPom,lii+1),lcPom)
lii=RAT(".",lcTable)
lcTable=IIF(lii>0,LEFT(lcTable,lii-1),lcTable)

llDal=.T. && Nastav pznak, e je ve OK

* Zjisti, zda tabulka ji existuje
lcATables=SYS(2015) && Pracovn kurzor
IF SQLTABLES(lihdbc,"'TABLE','VIEW','SYSTEM TABLE'",lcATables)<=0
   liErr=__DBF2ORA_ErrNoTables
   llDal=.F.
ENDIF

IF llDal
   STORE "" TO lcSQL,lcPom,lcSQLI
   * Nati seznam poloek
   FOR lii=1 TO AFIELDS(laFields,lcAlias)
       IF AT(laFields(lii,1),lcExList)>0
          LOOP
       ENDIF
       lcSQL=lcSQL+[ "]+laFields(lii,1)+[" ]+;
             IIF(laFields(lii,2)='C',"char ("+LTRIM(STR(laFields(lii,3),11))+")",;
             IIF(laFields(lii,2)='M',"varchar2(4000)",;
             IIF(laFields(lii,2)='Y',"decimal(15,4)",;
             IIF(laFields(lii,2)='F',"float",;
             IIF(laFields(lii,2)='B',"double",;
             IIF(laFields(lii,2)='I',"integer(11)",;
             IIF(laFields(lii,2)='N',"decimal("+LTRIM(STR(laFields(lii,3),3))+IIF(laFields(lii,4)=0,")",","+LTRIM(STR(laFields(lii,4),3))+")") ,;
             IIF(laFields(lii,2)$'D,T',"date",;
             IIF(laFields(lii,2)='G',"longblob","decimal(1)")))))))))+" "+IIF(laFields(lii,5),"NULL,","NOT NULL,")

       lcSQLI=lcSQLI+" ["+laFields(lii,1)+"], "
       lcPom=lcPom+"?"+lcAlias+"."+laFields(lii,1)+", "
   NEXT
   lcSQL="CREATE TABLE "+lcTable+" ("+LEFT(lcSQL,LEN(lcSQL)-1)+")"
   lcSQLI="INSERT INTO "+lcTable+" ("+LEFT(lcSQLI,LEN(lcSQLI)-2)+") VALUES ("+LEFT(lcPom,LEN(lcPom)-2)+")"

   SELE (lcATables)
   LOCATE FOR UPPER(ALLT(TABLE_OWNER))==UPPER(lcUser) AND UPPER(ALLT(TABLE_NAME))==UPPER(lcTable)
   llExists=FOUND()

   IF llExists AND llReCreate AND UPPER(ALLT(TABLE_TYPE))=='VIEW' OR UPPER(ALLT(TABLE_TYPE))=='SYSTEM TABLE'
      llDal=.F.
      liErr=__DBF2ORA_ErrNotaTable
   ENDIF
ENDIF

IF llDal AND (!llExists OR llReCreate)
   IF llExists AND SQLEXEC(lihdbc,"DROP TABLE "+lcTable)<=0
      llDal=.F.
      liErr=__DBF2ORA_ErrCannotDTable
   ENDIF

   IF llDal AND SQLEXEC(lihdbc,lcSQL)<=0
      llDal=.F.
      liErr=__DBF2ORA_ErrCannotCTable
   ENDIF
ENDIF

IF USED(lcATables) && Pokud je pracovn kurzor oteven
   USE IN (lcATables) && Pak jej uzavi
ENDIF

* Sma vty, pokud tabulka existuje a nebyla znovu vytvoena a m se naplnit
IF llDal AND llExists AND !llReCreate AND llReFill AND SQLEXEC(lihdbc,"DELETE FROM "+lcTable)<=0
   liErr=__DBF2ORA_ErrNotDelete
   llDal=.F.
ENDIF

IF llDal
   liErr=__DBF2ORA_ErrOK
   SELE (lcAlias)
   =SQLPREPARE(lihdbc,lcSQLI)
   SCAN ALL
       IF SQLEXEC(lihdbc,lcSQLI)<=0
          liErr=__DBF2ORA_ErrNotInsert
          EXIT
       ENDIF
   ENDSCAN
   * Pokud jsou nastaveny run transakce, pak bu potvr zmny, nebo je zru
   =IIF(SQLGETPROP(lihdbc,"Transactions")=2,IIF(liErr=__DBF2ORA_ErrOK,SQLCOMMIT(lihdbc),SQLROLLBACK(lihdbc)),.T.)
ENDIF
=SQLDISCONNECT(lihdbc) && Uzavi spojen
RETURN liErr

